﻿using System;
using System.Drawing;
using System.Windows.Forms;
using AForge.Video;
using System.Reflection;

namespace MJPGStreamerViewer
{
    public partial class Form1 : Form
    {
       
        struct myMargin
        {
            public int Width;
            public int Height;
        }

        myMargin MyMargin;

        public Form1()
        {

            InitializeComponent();
            MyMargin.Width = this.Width - this.videoSourcePlayer.Width;
            MyMargin.Height = this.Height - this.videoSourcePlayer.Height;

            #region useUnsafeHeaderParsing
            Assembly aNetAssembly = Assembly.GetAssembly(typeof(System.Net.Configuration.SettingsSection));
            if (aNetAssembly != null)
            {
                Type aSettingsType = aNetAssembly.GetType("System.Net.Configuration.SettingsSectionInternal");
                if (aSettingsType != null)
                {
                    object anInstance = aSettingsType.InvokeMember("Section",
                    BindingFlags.Static | BindingFlags.GetProperty | BindingFlags.NonPublic, null, null, new object[] { });
                    if (anInstance != null)
                    {
                        FieldInfo aUseUnsafeHeaderParsing = aSettingsType.GetField("useUnsafeHeaderParsing", BindingFlags.NonPublic | BindingFlags.Instance);
                        if (aUseUnsafeHeaderParsing != null)
                        {
                            aUseUnsafeHeaderParsing.SetValue(anInstance, true);
                        }
                    }
                }
            }
            #endregion
        }


        private void MainForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            CloseCurrentVideoSource();
            videoSourcePlayer.VideoSource = null;
        }

        private void CloseCurrentVideoSource()
        {
            if (videoSourcePlayer.VideoSource != null)
            {
                videoSourcePlayer.SignalToStop();

                for (int i = 0; i < 30; i++)
                {
                    if (!videoSourcePlayer.IsRunning) break;
                    System.Threading.Thread.Sleep(100);
                }

                if (videoSourcePlayer.IsRunning)
                {
                    videoSourcePlayer.Stop();
                }

                videoSourcePlayer.VideoSource = null;
            }
        }

        private void Form1_Resize(object sender, EventArgs e)
        {
            if (this.Width > this.Height)
            {
                this.videoSourcePlayer.Height = this.Height - MyMargin.Height;
                this.videoSourcePlayer.Width = this.videoSourcePlayer.Height * 3 / 2;
            }
            else
            {
                this.videoSourcePlayer.Width = this.Width - MyMargin.Width;
                this.videoSourcePlayer.Height = this.videoSourcePlayer.Width * 2 / 3;
            }

            this.videoSourcePlayer.Location = new Point( (this.Width - this.videoSourcePlayer.Width) / 2, 0);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            CloseCurrentVideoSource();
            videoSourcePlayer.VideoSource = new MJPEGStream(this.textBox1.Text);
            videoSourcePlayer.Start();
            this.Cursor = Cursors.Default;
        }
    }
}
