﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using System.Reflection;

namespace MJPGStreamerViewer
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            var resourcedAssembliesHash = new Dictionary<string, byte[]> {
                {"AForge",  Properties.Resources.AForge},
                {"AForge.Controls",  Properties.Resources.AForge_Controls},
                {"AForge.Imaging",  Properties.Resources.AForge_Imaging},
                {"AForge.Video",  Properties.Resources.AForge_Video}
            };

            AppDomain.CurrentDomain.AssemblyResolve += (sender, args) =>
            {
                var assemblyName = args.Name.Split(',').First();

                if (resourcedAssembliesHash.ContainsKey(assemblyName))
                {
                    return Assembly.Load(resourcedAssembliesHash[assemblyName]);
                }

                return null;
            };

            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new Form1());
        }

    }
}
